#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "Templates/SubclassOf.h"
#include "K31P02.generated.h"

class UStatusEffect;
class ASurvivor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class THEK31_API UK31P02 : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere)
	float _screamRevealSeconds;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _screamDistance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _revealAuraToKillerEffectClass;

private:
	UFUNCTION(BlueprintCallable, NetMulticast, Reliable)
	void Multicast_MakeSurvivorsScream(const TArray<ASurvivor*>& survivorsToScream);

public:
	UFUNCTION(BlueprintPure)
	float GetScreamRevealDuration() const;

	UFUNCTION(BlueprintPure)
	float GetScreamDistance() const;

public:
	UK31P02();
};

FORCEINLINE uint32 GetTypeHash(const UK31P02) { return 0; }
